#include "stdio.h"
#include "math.h"
#include "stdlib.h"
#include "string.h"
#define SUBRATE   .009999 

int *treeL,*treeR;
int ***group;
int **noOfGroup;
int treeE;
double freqObs[20], freq[20], prob[20][20], ***probNode;
double transition[20][20];
int **sequenceN;
int *parent;
double ***probability;
int seqNum,seqLength;
int **downPass, **upPass, ***multiState;
int **assignment;
int **noOfStates;
int *totalPath;
int *branchL,*branchR;

int main(int argv, char *argc[])
{       void binaryGo(int,int,int);
        void matrix();
        int parsimony(int);
        void jttf();
        int change(char);
        double totalProb(int);
        double nodeByNode(int,int,int);
	FILE *fopen(),*fptr1,*fptr2,*fptr3,*fptr4,*fptr5;
	int fclose();
        char **sequence;
        char **seqName;
        int *name,*steps,anInt,i,j,jj,k,k1,k2,max, minimum, min, flag, left, right,noOfMPP,search,jttF;
        char aChar;
        double max1,good,**distance, **bestFreq, **tempFreq;
        int **best;
        double y,a,aDouble;
        double *probPath2,probPath;
        double *length;
        int x[5];
        int *box;
        double **w;
        int *order, *parsiStep;
        char aminoAcid[20]={'A','R','N','D','C','Q','E','G','H','I','L','K','M','F','P','S','T','W','Y','V'};

        printf("Search mode?\n 1: All pathways (suggested for seqNum [number of sequences]<=8)\n 2: Extended parsimony pathways (suggested for 9<=seqNum<=16);\n 3: Node by node (suggested for seqNum>=17)\n");
        scanf("%d",&search);
 /*     printf("Substitution model?\n 0: JTT; 1: JTT-f\n");
        scanf("%d",&jttF);
 */
        jttF=1;
        if((fptr1=fopen(argc[1],"r"))==NULL) { printf("Can't open the file!\n"); exit(1);}
        fscanf(fptr1,"%d",&seqNum); fscanf(fptr1,"%d",&seqLength);
        tempFreq=malloc(sizeof(double *)*seqNum);
           for(i=0;i<seqNum;i++) tempFreq[i]=malloc(sizeof(double)*20);
        best=malloc(sizeof(int *)*seqLength);
           for(i=0;i<seqLength;i++) best[i]=malloc(sizeof(int)*seqNum);
        bestFreq=malloc(sizeof(double *)*seqLength);
           for(i=0;i<seqLength;i++) bestFreq[i]=malloc(sizeof(double)*seqNum);
        totalPath=malloc(sizeof(int)*seqLength);
        noOfStates=malloc(sizeof(int *)*seqLength);
           for(i=0;i<seqLength;i++)  noOfStates[i]=malloc(sizeof(int)*(seqNum*2-1));
 	downPass=malloc(sizeof(int *)*(seqNum*2-1));
	     for (i=0;i<2*seqNum-1;i++) downPass[i]=malloc(sizeof(int)*20);
        upPass=malloc(sizeof(int *)*(seqNum*2-1));
	     for (i=0;i<2*seqNum-1;i++) upPass[i]=malloc(sizeof(int)*20);
        multiState=malloc(sizeof(int **)*seqLength);
	     for (i=0;i<seqLength;i++) multiState[i]=malloc(sizeof(int *)*(2*seqNum-1));
	     for (i=0;i<seqLength;i++){
                for (j=0;j<2*seqNum-1;j++) {
                   multiState[i][j]=malloc(sizeof(int)*20);
	        }
	     }

        probNode=malloc(sizeof(double **)*seqLength);
            for (i=0;i<seqLength;i++) probNode[i]=malloc(sizeof(double *)*(seqNum-1));
            for (i=0;i<seqLength;i++){
                for (j=0;j<seqNum-1;j++) {
                   probNode[i][j]=malloc(sizeof(double)*20);
	        }
	     }
        parsiStep=malloc(sizeof(int)*seqLength);
        sequence=malloc(sizeof(char *)*seqNum);
             for(i=0;i<seqNum;i++) sequence[i]=malloc(sizeof(char)*seqLength);
        sequenceN=malloc(sizeof(int *)*seqNum);
             for(i=0;i<seqNum;i++) sequenceN[i]=malloc(sizeof(int)*seqLength);
        name=malloc(sizeof(char *)*seqNum);
        seqName=malloc(sizeof(char *)*seqNum);
             for (i=0;i<seqNum;i++) seqName[i]=malloc(sizeof(char)*20);

    	treeL=malloc(sizeof(int)*seqNum*2);
        treeR=malloc(sizeof(int)*seqNum*2);
        distance=malloc(sizeof(double *)*seqNum);
             for (i=0;i<seqNum;i++) distance[i]=malloc(sizeof(double)*seqNum);
        length=malloc(sizeof(double)*(seqNum*2-3));
        branchL=malloc(sizeof(int)*(seqNum*2-3));
        branchR=malloc(sizeof(int)*(seqNum*2-3));
        parent=malloc(sizeof(int)*(seqNum*2-1));
        noOfGroup=malloc(sizeof(int)*(seqNum*2-3));
             for (i=0;i<=seqNum*2-4;i++) noOfGroup[i]=malloc(sizeof(int)*5);
	box=malloc(sizeof(int)*(seqNum+1));
        group=malloc(sizeof(int **)*(seqNum*2-3));
            for (i=0;i<=seqNum*2-4;i++)
               group[i]=malloc(sizeof(int *)*5);
            for (i=0;i<=seqNum*2-4;i++) {
               for (j=0;j<5;j++) {
                  group[i][j]=malloc(sizeof(int)*(seqNum-2));
	       }
	    }
        w=malloc(sizeof(double *)*(seqNum*2-3));
            for(i=0;i<seqNum*2-3;i++) w[i]=malloc(sizeof(double)*6);
        order=malloc(sizeof(int)*(seqNum*2-3));
        probability=malloc(sizeof(double **)*(2*seqNum-3));
	    for(i=0;i<seqNum*2-3;i++) probability[i]=malloc(sizeof(double *)*20);
	    for(i=0;i<seqNum*2-3;i++) {
	      for(j=0;j<20;j++) probability[i][j]=malloc(sizeof(double)*20);
            }

	for(i=0;i<seqNum*2;i++) { treeL[i]=0;treeR[i]=0;}
        for(i=0;i<seqNum+1;i++) box[i]=i;
        for(i=0;i<seqNum*2-3;i++) length[i]=.0;
        for(i=0;i<20;i++) {
           for(j=0;j<20;j++) {
               if(i==j) transition[i][j]=1.0;
               else {  transition[i][j]=.0;}
	     }
	 }
/* READ SEQUENCE DATA */

        for(i=0;i<seqNum;i++) {
           while(fgetc(fptr1)!='\n'){}
           j=0;
      	  while (j<20&&(seqName[i][j]=fgetc(fptr1))!='\n') {j=j+1;}
           name[i]=j;
           if((j==20)&&(seqName[i][20]!='\n')) {seqName[i][20]='\n'; while(fgetc(fptr1)!='\n') {}}
           for(j=0;j<seqLength;j++) sequence[i][j]=fgetc(fptr1);
        }

       
/* READ TREE TOPOLOGY */
   while(fgetc(fptr1)!='\n'){}
	i=seqNum+1;max=i;left=1;right=0;
        while(fgetc(fptr1)!='('){}
        while((aChar=fgetc(fptr1))!='\n'&&aChar!=EOF) {
          if(aChar!=' '&&aChar!=',') {
            if(aChar=='(') {left=left+1;
                            if(treeL[i]==0){treeL[i]=i+1;i=i+1;max=max+1;}
                             else{ if (treeR[i]==0) {treeR[i]=max+1;max=max+1;i=max;}
                                   else {treeE=max+1;max=max+1;i=max;}
                             }
	    }
            else {if(aChar==')') {
                     right=right+1;
                     for(j=seqNum+1;j<=seqNum*2-2;j++){
                          if(treeL[j]==i||treeR[j]==i) goto out50;
                     }
                     out50:;
                     i=j;
                   }
                  else {ungetc(aChar,fptr1);
                          if(treeL[i]==0)  {fscanf(fptr1,"%d",&treeL[i]);}
			     else {if(treeR[i]==0) fscanf(fptr1,"%d",&treeR[i]);
                                     else fscanf(fptr1,"%d",&treeE);
				  }
		    }
	    }
          }
       }
	if(left!=right) {printf("Wrong topology!");fflush(stdout);exit(0);}
        fclose(fptr1);

/*COMPUTING GAMMA DISTANCES */

	a=2.4;
      	for (i=0;i<seqNum-1;i++) {
	  for(j=i+1;j<seqNum;j++) {
             distance[i][j]=.0;
             for(k=0;k<seqLength;k++) {
                if(sequence[i][k]!=sequence[j][k]) distance[i][j]=distance[i][j]+1.0/seqLength;
	      }
             distance[i][j]=a*(pow(1.0-distance[i][j],-1.0/a)-1.0);
	   }
        }


/* LEAST-SQUARE BRANCH LENGTH ESTIMATION */
   /* determin the four groups */
	j=seqNum+1;
	for(i=0;i<=seqNum-3;i++){
	  branchL[i]=j;
	  branchR[i]=treeL[j];
	  j=j+1;
	}

   j=seqNum+1;
	for(i=seqNum-2;i<=seqNum*2-5;i++){
	  branchL[i]=j;
	  branchR[i]=treeR[j];
	  j=j+1;
	}

        branchL[seqNum*2-4]=seqNum+1;
        branchR[seqNum*2-4]=treeE;

	for(i=1;i<=seqNum*2-2;i++) {
         for (j=seqNum+1;j<=seqNum*2-2;j++) {
             if((treeL[j]-i)*(treeR[j]-i)==0) parent[i]=j;
	      }
   }
        parent[treeE]=seqNum+1;
        parent[seqNum+1]=treeE;



        for (i=0;i<seqNum*2-3;i++){
             for(k=1;k<=4;k++) {
                noOfGroup[i][k]=0;
                for (j=0;j<=seqNum-2;j++) {
                   group[i][k][j]=0;

	         	 }
	          }
        }

 for(i=0;i<seqNum*2-3;i++){
   for(j=0;j<seqNum+1;j++) box[j]=j;
       minimum=seqNum+1;
	  if(branchR[i]>seqNum) {
      	  x[3]=treeL[branchR[i]];
           x[4]=treeR[branchR[i]];
           x[1]=parent[branchL[i]];
           if(branchL[i]==seqNum+1) x[1]=treeL[seqNum+1];
           x[2]=treeR[branchL[i]]; if(x[2]==branchR[i]) x[2]=treeL[branchL[i]];

           for(k=1;k<=4;k++) {
              if(x[k]>seqNum && minimum>abs(seqNum+1-x[k])){ minimum=abs(seqNum+1-x[k]); min=k;}
	        }
           for(k=1;k<=4;k++) {
             if(k!=min) {
               if(x[k]>seqNum) {binaryGo(i,k,x[k]);}
               else { noOfGroup[i][k]=1; group[i][k][0]=x[k];}
	     }
           }
           noOfGroup[i][min]=seqNum-noOfGroup[i][1]-noOfGroup[i][2]-noOfGroup[i][3]-noOfGroup[i][4];


	   for(j=1;j<=4;j++) {
             if(j!=min) {
              for(k=0;k<noOfGroup[i][j];k++)  {box[group[i][j][k]]=-1;}
             }
           }
           j=0;
           for(k=1;k<=seqNum;k++){
                if(box[k]!=-1) {group[i][min][j]=box[k];j=j+1;}
	   }

           w[i][0]=-.5/noOfGroup[i][1]/noOfGroup[i][2];
           w[i][1]=1.0*(noOfGroup[i][2]*noOfGroup[i][3]+noOfGroup[i][1]*noOfGroup[i][4]+.0)/((noOfGroup[i][1]+noOfGroup[i][2])*(noOfGroup[i][3]+noOfGroup[i][4])*(2.0*noOfGroup[i][1]*noOfGroup[i][3])+.0);
           w[i][2]=1.0*(noOfGroup[i][1]*noOfGroup[i][3]+noOfGroup[i][2]*noOfGroup[i][4]+.0)/((noOfGroup[i][1]+noOfGroup[i][2])*(noOfGroup[i][3]+noOfGroup[i][4])*(2.0*noOfGroup[i][1]*noOfGroup[i][4])+.0);
           w[i][3]=1.0*(noOfGroup[i][1]*noOfGroup[i][3]+noOfGroup[i][2]*noOfGroup[i][4]+.0)/((noOfGroup[i][1]+noOfGroup[i][2])*(noOfGroup[i][3]+noOfGroup[i][4])*(2.0*noOfGroup[i][2]*noOfGroup[i][3])+.0);
           w[i][4]=1.0*(noOfGroup[i][2]*noOfGroup[i][3]+noOfGroup[i][1]*noOfGroup[i][4]+.0)/((noOfGroup[i][1]+noOfGroup[i][2])*(noOfGroup[i][3]+noOfGroup[i][4])*(2.0*noOfGroup[i][2]*noOfGroup[i][4])+.0);
           w[i][5]=-.5/(noOfGroup[i][3]*noOfGroup[i][4]+.0);
	  }


          else{
           noOfGroup[i][4]=-1;
           noOfGroup[i][3]=1; group[i][3][0]=branchR[i];
           x[1]=parent[branchL[i]];
           if(branchL[i]==seqNum+1) x[1]=treeL[seqNum+1];
           x[2]=treeR[branchL[i]];
           if(x[2]==branchR[i]) x[2]=treeL[branchL[i]];


           for(k=1;k<=4;k++) {
              if(x[k]>seqNum && minimum>abs(seqNum+1-x[k])){ minimum=abs(seqNum+1-x[k]); min=k; goto out999;}
	        }
           out999:;  

           for(k=1;k<=2;k++) {
             if(k!=min) {
               if(x[k]>seqNum) {binaryGo(i,k,x[k]);}
               else { noOfGroup[i][k]=1; group[i][k][0]=x[k];}
	         }
           }
           noOfGroup[i][min]=seqNum-noOfGroup[i][1]-noOfGroup[i][2]-noOfGroup[i][3];
           for(j=1;j<=3;j++) {
             if(j!=min) {
              for(k=0;k<noOfGroup[i][j];k++)  box[group[i][j][k]]=-1;
             }
           }
           j=0;
           for(k=1;k<=seqNum;k++){
                if(box[k]!=-1) {group[i][min][j]=box[k];j=j+1;}
	   }

           w[i][0]=.5/noOfGroup[i][1];
           w[i][1]=.5/noOfGroup[i][2];
           w[i][2]=-.5/(noOfGroup[i][1]*noOfGroup[i][2]);
	  }

        }

   /*branch lengths estimation*/

       for(i=0;i<seqNum*2-3;i++) {
           if(branchR[i]>seqNum) {
             for(j=1;j<=seqNum-1;j++) {
                   for(k1=1;k1<=4;k1++) {
                         for(k2=0;k2<noOfGroup[i][k1];k2++) {
                                 if(j==group[i][k1][k2]) left=k1;
		         }
		       }

                         for(k=j+1;k<=seqNum;k++) {
                           for(k1=1;k1<=4;k1++) {
                               for(k2=0;k2<noOfGroup[i][k1];k2++) {
                                 if(k==group[i][k1][k2]) right=k1;
			       }
		           }
	    	           if((left==1&&right==2)||(left==2&&right==1)) length[i]=length[i]+distance[j-1][k-1]*w[i][0];
                           if((left==1&&right==3)||(left==3&&right==1)) length[i]=length[i]+distance[j-1][k-1]*w[i][1];
                           if((left==1&&right==4)||(left==4&&right==1)) length[i]=length[i]+distance[j-1][k-1]*w[i][2];
                           if((left==2&&right==3)||(left==3&&right==2)) length[i]=length[i]+distance[j-1][k-1]*w[i][3];
                           if((left==2&&right==4)||(left==4&&right==2)) length[i]=length[i]+distance[j-1][k-1]*w[i][4];
                           if((left==3&&right==4)||(left==4&&right==3)) length[i]=length[i]+distance[j-1][k-1]*w[i][5];
		         }
            }
         }

         else {
           for(j=1;j<=seqNum-1;j++) {
                     for(k1=1;k1<=3;k1++) {
                           for(k2=0;k2<noOfGroup[i][k1];k2++) {
                                 if(j==group[i][k1][k2]) left=k1;
			   }
		     }

                     for(k=j+1;k<=seqNum;k++) {
                           for(k1=1;k1<=3;k1++) {
                               for(k2=0;k2<noOfGroup[i][k1];k2++) {
                                 if(k==group[i][k1][k2]) right=k1;
			       }
		           }
		          if((left==1&&right==3)||(left==3&&right==1)) length[i]=length[i]+distance[j-1][k-1]*w[i][0];
                          if((left==2&&right==3)||(left==3&&right==2)) length[i]=length[i]+distance[j-1][k-1]*w[i][1];
                          if((left==1&&right==2)||(left==2&&right==1)) length[i]=length[i]+distance[j-1][k-1]*w[i][2];

		     }
	   }
         }
       }



/*
for (i=0;i<=14;i++) {printf("%f ",length[i]);}

length[6]=.07579;length[13]=.03349;length[5]=.00032;length[12]=.0795;length[4]=.03543;length[11]=.28018;length[3]=.04541;length[10]=.25748;length[2]=.12206;length[9]=.31926;length[1]=.13377;length[8]=.39697;length[0]=.27285;length[7]=.12524;length[14]=.26649;
printf("%\n");
for (i=0;i<=14;i++) {printf("%f ",length[i]);}
*/
/*
	fptr4=fopen("infile","w");
        fprintf(fptr4,"     %d\n",seqNum);

        for (i=0;i<seqNum;i++) { fprintf(fptr4,"%d      ",(i+1)*10000);
          for (j=0;j<i;j++) {
            fprintf(fptr4,"%2.4f ",distance[j][i]);
	  }
          fprintf(fptr4,"%2.4f ",.0);
          for (j=i+1;j<seqNum;j++) {
            fprintf(fptr4,"%2.4f ",distance[i][j]);
	  } fprintf(fptr4,"\n");
	}
        fprintf(fptr4,"%d\n",1);
	fptr5=fopen("tree","r");
        while((aChar=fgetc(fptr5))!='\n'&&(aChar!=EOF)) {
            if((aChar=='(')||(aChar==')')||(aChar==',')) fprintf(fptr4,"%c",aChar);
                else {
                 ungetc(aChar,fptr5);
                 fscanf(fptr5,"%d",&anInt);
                 fprintf(fptr4,"%d0000",anInt);
                }
        }
        fprintf(fptr4,";");
        fclose(fptr5);
	fclose(fptr4);
        system("walter infile");
        fptr5=fopen("outfile","r");
        for (i=1;i<=2*seqNum-3;i++) {
             fscanf(fptr5,"%d %d %lf",&left,&right,&good);
             if(left>9999) {left=left/10000;}
                else {left=seqNum+left;}
             if(right>9999){right=right/10000;}
                else { right=seqNum+right;}
             for(j=0;j<=seqNum*2-4;j++) {
                  if((left==branchL[j]&&right==branchR[j])||(left==branchR[j]&&right==branchL[j])) {length[j]=good;}
	     }
	}
        fclose(fptr5);
	for (i=0;i<=14;i++) {printf("%f ",length[i]);}
*/
printf("\nBranch length estimation done");fflush(stdout);
/*
length[0]=.0583;length[1]=.0163;length[2]=.0;length[3]=.0341;length[4]=.0002;length[5]=.0248;length[6]=.0308;length[7]=.0207;length[8]=.1987;length[9]=.0844;length[10]=.06;length[11]=.0;length[12]=.0511;length[13]=.0078;length[14]=.016;length[15]=.0;length[16]=.0235;length[17]=.0676;length[18]=.0;
*/

/* READ SUBSTITUTION MATRIX */
        fptr3=fopen("jtt.pro","r");
	for (i=0;i<20;i++) fscanf(fptr3,"%lf", &freq[i]);
        for (i=0;i<20;i++) {
          for (j=0;j<20;j++) {
              fscanf(fptr3,"%lf", &prob[i][j]);
          }
        }


        for(i=0;i<seqNum;i++) {
           for(j=0;j<seqLength;j++) {
              sequenceN[i][j]=change(sequence[i][j]);
           }
        }

        if(jttF==1) jttf();

/* COMPUTE TRANSITION MATRIX FOR EACH BRANCH */
        for (i=0;i<seqNum*2-3;i++){if(length[i]<.0) length[i]=.0;}
        order[0]=0;
        for (i=1;i<seqNum*2-3;i++){
            if(length[i]<length[order[i-1]]) {
              if(length[i]<length[order[0]]) {
                     for(k=i;k>0;k--) {order[k]=order[k-1];}
                     order[0]=i;
                     goto out100;
              }
	      else {
                for(j=i-1;j>=0;j--) {
                 if(length[i]>=length[order[j]]) {
                   for(k=i;k>j+1;k--) {order[k]=order[k-1];}
                   order[j+1]=i;
                   goto out100;
                 }
	        }
              }
	    }
            else {order[i]=i;}
            out100:;
        }

/* for(i=0;i<seqNum*2-3;i++) printf("%d %f   ",order[i],length[order[i]]); */
        i=0;
	while (length[order[i]]*100.0<1.0) {
    	  for (j=0;j<20;j++) {
	    for(k=0;k<20;k++) {
                 if(j!=k) probability[order[i]][j][k]=prob[j][k]*length[order[i]]*100;
                 else { probability[order[i]][j][k]=1.0-length[order[i]]*100*(1.0-prob[j][k]);}
	    }
          }
          i=i+1;
        }


	for(j=1;j<=100*length[order[2*seqNum-4]];j++) {
	  matrix();
          out101:;
          if((anInt=100*length[order[i]])==j) {
             for (k1=0;k1<20;k1++) {
                 for(k2=0;k2<20;k2++) {
                    if(k1!=k2) probability[order[i]][k1][k2]=transition[k1][k2]+prob[k1][k2]*(100.0*length[order[i]]-j);                     else{ probability[order[i]][k1][k2]=transition[k1][k2]-(1.0-prob[k1][k2])*(100.0*length[order[i]]-j);}
		 }
             }
          i=i+1;
          if (i<=seqNum*2-4) goto out101;
	  }
        }

   free(order); free(group); free(noOfGroup);

printf("\nTransition matrix computation done");fflush(stdout);

/* OUTPUT THE SEQUENCES AND TREE */

        fptr2=fopen("result","w");
        fprintf(fptr2,"Number of sequences = %d\n",seqNum);
        fprintf(fptr2,"Sequence length = %d sites\n ",seqLength);
        fprintf(fptr2,"\nPresent-day sequences\n");
	for(i=0;i<seqNum;i++) {
          fprintf(fptr2,"\n");
          for(j=0;j<name[i];j++) fprintf(fptr2,"%c",seqName[i][j]);
          fprintf(fptr2,"\n");
          for(j=0;j<seqLength;j++) fprintf(fptr2,"%c",sequence[i][j]);
	}
        fprintf(fptr2,"\n");
/*
	for (i=seqNum+1;i<seqNum*2-1;i++) {
           fprintf(fptr2,"\ni=%d L=%d R=%d",i,treeL[i],treeR[i]);
        }

        fprintf(fptr2,"\ntreeE=%d\n\n",treeE);
*/
		  fprintf(fptr2,"\nDistance matrix (Gamma distances with alpha=2.4)\n\n");
        fprintf(fptr2,"  ");
        for (i=1;i<=seqNum;i++) {
           fprintf(fptr2,"%6d",i);
        }
        fprintf(fptr2,"\n\n");
        for (i=0;i<seqNum;i++) { fprintf(fptr2,"%2d  ",i+1);
          for (j=0;j<i;j++) {
            fprintf(fptr2,"%1.3f ",distance[j][i]);
	  }
          fprintf(fptr2,"%1.3f ",.0);
          for (j=i+1;j<seqNum;j++) {
            fprintf(fptr2,"%1.3f ",distance[i][j]);
	  } fprintf(fptr2,"\n");
	}
        fprintf(fptr2,"\nBranch  node   node    length");
        for (i=0;i<seqNum*2-3;i++){
             fprintf(fptr2,"\n%3d:    %3d    %3d     %1.4f",i,branchL[i],branchR[i], length[i]);
	}
       fprintf(fptr2,"\n\n");



printf("\nBegin reconstructing");fflush(stdout);

/* RECONSTRUTING ANCESTRAL STATES */

     	for (i=0;i<seqLength;i++) {
            parsiStep[i]=parsimony(i);
	}

 if(search==3) goto out9999;
 fprintf(fptr2,"site, extant states, ancestral pathways, posterior probability | # of pasimony pathways: # of parsimony steps (* means a parsimony pathway)");
 if(search==1) {
           for (i=0;i<seqLength;i++) {
              k1=1;
              multiState[i][seqNum+1][0]=sequenceN[0][i];
              for(j=1;j<seqNum;j++) {
                flag=1;
                for(k=0;k<j;k++){
                     if(sequenceN[j][i]==sequenceN[k][i]) flag=0;
		}
                if(flag==1) {multiState[i][seqNum+1][k1]=sequenceN[j][i];k1=k1+1;}
	      }
              noOfStates[i][seqNum+1]=k1;
              totalPath[i]=k1;
              for(j=seqNum+2;j<=2*seqNum-2;j++) {
                  noOfStates[i][j]=k1; totalPath[i]=totalPath[i]*k1;
                  for(k=0;k<k1;k++)  multiState[i][j][k]=multiState[i][seqNum+1][k];
	      }

	   }
 }
 if(search==2) {
          for (i=0;i<seqLength;i++) {
            totalPath[i]=1;
            for(j=seqNum+1;j<=seqNum*2-2;j++) {
               noOfStates[i][j]=0;
               for(k=0;k<20;k++) {
                    if(multiState[i][j][k]>=0) noOfStates[i][j]=noOfStates[i][j]+1;
      	      }
               totalPath[i]=totalPath[i]*noOfStates[i][j];
            }
	      }
 }

	for(i=0;i<seqLength;i++) { printf("\nsite #%d:   %d pathways",i+1,totalPath[i]);fflush(stdout);

            steps=malloc(sizeof(int)*totalPath[i]);
            probPath2=malloc(sizeof(double)*totalPath[i]);
            assignment=malloc(sizeof(int *)*totalPath[i]);
            for(j=0;j<totalPath[i];j++) {
               assignment[j]=malloc(sizeof(int)*(seqNum-1));
            }

	    min=1;
            for(j=seqNum+1;j<=2*seqNum-2;j++) {
                for(k=0;k<min;k++) {
                   for(k2=0;k2<noOfStates[i][j];k2++) {
                       for(k1=0;k1<totalPath[i]/(min*noOfStates[i][j]);k1++) {
                       assignment[totalPath[i]/min*k+totalPath[i]/min/noOfStates[i][j]*k2+k1][j-seqNum]=multiState[i][j][k2];
		     }
		   }
              	}
                min=min*noOfStates[i][j];
            }
/*          fprintf(fptr2,"\n%d: ",i+1);printf("OK");fflush(stdout);
            for (j=0;j<totalPath[i];j++) {
                 fprintf(fptr2," ");
                 for(k=seqNum+1;k<=2*seqNum-2;k++) {
                     fprintf(fptr2,"%c",aminoAcid[assignment[j][k-seqNum]]);
                 }
            }
*/

	    for (j=0;j<totalPath[i];j++){
               steps[j]=0;
               probPath2[j]=freq[assignment[j][1]];
               for(k=1;k<=seqNum;k++) {
                   left=assignment[j][parent[k]-seqNum]; right=sequenceN[k-1][i];
                   if(right!=left) steps[j]=steps[j]+1;
                   for(k1=0;k1<=seqNum*2-4;k1++) {
                       if(branchL[k1]==parent[k]&&branchR[k1]==k) goto out400;
		   }
		   out400:;
                   probPath2[j]=probPath2[j]*probability[k1][left][right];
	       }
               for (k=seqNum+1;k<=seqNum*2-2;k++) {
                   if(treeL[k]<=seqNum) goto out404;
		   for(k1=0;k1<=seqNum*2-4;k1++) {
                       if(branchL[k1]==k && branchR[k1]==treeL[k]) goto out401;
		   }
		   out401:;
                   left=assignment[j][k-seqNum]; right=assignment[j][treeL[k]-seqNum];
                   if(left!=right) steps[j]=steps[j]+1;

                   probPath2[j]=probPath2[j]*probability[k1][left][right];
                   out404:;
               }
               for (k=seqNum+1;k<=seqNum*2-2;k++) {
		   if(treeR[k]<=seqNum) goto out403;
		   for(k1=0;k1<=seqNum*2-4;k1++) {
                       if(branchL[k1]==k && branchR[k1]==treeR[k]) goto out402;
		   }
		   out402:;
                   left=assignment[j][k-seqNum];
                   right=assignment[j][treeR[k]-seqNum];
                   if(left!=right) steps[j]=steps[j]+1;
                   probPath2[j]=probPath2[j]*probability[k1][left][right];
                   out403:;
               }
	       if(treeE>seqNum) {
                   left=assignment[j][1]; right=assignment[j][treeE-seqNum];
                   if(left!=right) steps[j]=steps[j]+1;
                   probPath2[j]=probPath2[j]*probability[2*seqNum-4][left][right];
               }


	     }
          probPath=totalProb(i);
          noOfMPP=0;
          fprintf(fptr2,"\n%d ",i+1);
          for(j=1;j<seqNum+1;j++)  fprintf(fptr2,"%c",aminoAcid[sequenceN[j-1][i]]);
          fprintf(fptr2,"  ");
          for(j=0;j<totalPath[i];j++) {
            y=probPath2[j]/probPath;
	    if(steps[j]==parsiStep[i]) {
                   noOfMPP=noOfMPP+1;
                   for(k=seqNum+1;k<=seqNum*2-2;k++)  fprintf(fptr2,"%c",aminoAcid[assignment[j][k-seqNum]]);
                   fprintf(fptr2,"* ");
                   if(y>=.01) { fprintf(fptr2,"%1.3f",y);
                                fprintf(fptr2," ");
		   }
	    }
            else { if(y>=.01){
                         for(k=seqNum+1;k<=seqNum*2-2;k++)  fprintf(fptr2,"%c",aminoAcid[assignment[j][k-seqNum]]);
                         fprintf(fptr2," %1.3f ",y);
                   }
            }
         }
            fprintf(fptr2,"|%d:%d",noOfMPP,parsiStep[i]);

            for(j=seqNum+1;j<=seqNum*2-2;j++) {
                for(k=0;k<20;k++) {
                    tempFreq[j-seqNum][k]=.0;
	        }
            }

	    for(j=0;j<totalPath[i];j++) {
               for(k=seqNum+1;k<=seqNum*2-2;k++) {

		  if((good=probPath2[j]/probPath)<.0000001) good=.0000001;
                  tempFreq[k-seqNum][assignment[j][k-seqNum]]=tempFreq[k-seqNum][assignment[j][k-seqNum]]+good;
		}
	     }

            for(k=seqNum+1;k<=seqNum*2-2;k++) {
               bestFreq[i][k-seqNum]=-.1;
               for(j=0;j<20;j++) {
                 if(tempFreq[k-seqNum][j]>bestFreq[i][k-seqNum]) {bestFreq[i][k-seqNum]=tempFreq[k-seqNum][j];best[i][k-seqNum]=j;}
	       }
   	    }
            free(assignment); free(steps); free(probPath2);
	}


goto out151;

out9999:;
  for(i=0;i<seqLength;i++) {
    printf("\nsite%d ",i+1);fflush(stdout);
    probPath=totalProb(i);
    for(j=seqNum+1;j<=seqNum*2-2;j++) {
       max1=.0;
       for(k=0;k<20;k++) {
                  probNode[i][j-seqNum][k]=nodeByNode(i,j,k)/probPath;
                  if(probNode[i][j-seqNum][k]>max1) {max1= probNode[i][j-seqNum][k]; max=k;}

       }   best[i][j-seqNum]=max; bestFreq[i][j-seqNum]=max1;
    }
  }



out151:;
	fprintf(fptr2,"\n\n");
   fprintf(fptr2,"site, extant states, ancestral states, posterior probabilities");

	for(i=0;i<seqLength;i++) {
          fprintf(fptr2,"\n%4d ",i+1);
          for(j=1;j<seqNum+1;j++)  fprintf(fptr2,"%c",aminoAcid[sequenceN[j-1][i]]);
          fprintf(fptr2,"   ");
          for(j=seqNum+1;j<=seqNum*2-2;j++) {
              fprintf(fptr2,"%c %1.3f  ",aminoAcid[best[i][j-seqNum]],bestFreq[i][j-seqNum]);
          }
        }

fprintf(fptr2,"\n");
fprintf(fptr2,"\n\nAncestral sequences:");
for(i=seqNum+1;i<=seqNum*2-2;i++) {
fprintf(fptr2,"\nnode %d\n",i);
  for(j=0;j<seqLength;j++) {
     fprintf(fptr2,"%c",aminoAcid[best[j][i-seqNum]]);
   }
}

fprintf(fptr2,"\n\nAverage accuracy:");
for(i=seqNum+1;i<=seqNum*2-2;i++) {
  aDouble=.0;
  for(j=0;j<seqLength;j++) {
     aDouble=aDouble+bestFreq[j][i-seqNum];
   }
  fprintf(fptr2,"\nnode %d %f",i,aDouble/(seqLength+.0));
}

fclose(fptr2);
printf("\nDONE!\n");

}


/* DETERMINE FOUR GROUPS */

void binaryGo(int branchI, int groupI, int j)
{ 
  if(treeL[j]>seqNum) {
     binaryGo(branchI,groupI,treeL[j]);
  }
 
  if(treeL[j]<seqNum+1) {
  group[branchI][groupI][noOfGroup[branchI][groupI]]=treeL[j];
  noOfGroup[branchI][groupI]=noOfGroup[branchI][groupI]+1;
  }
  if(treeR[j]>seqNum){
     binaryGo(branchI,groupI,treeR[j]);
  }
  if(treeR[j]<seqNum+1){
  group[branchI][groupI][noOfGroup[branchI][groupI]]=treeR[j];
  noOfGroup[branchI][groupI]=noOfGroup[branchI][groupI]+1;
  }  
  
}



/* MATRIX MULTIPLICATION */

void matrix()
{ int i,j,k;
  double temp[20][20];
  for (i=0;i<20;i++) {
    for (j=0;j<20;j++) {
      temp[i][j]=.0;
      for(k=0;k<20;k++) {
        temp[i][j]=temp[i][j]+transition[i][k]*prob[k][j];
      }
    }
  }
    for (i=0;i<20;i++) {
    for (j=0;j<20;j++) { transition[i][j]=temp[i][j];}}
 
}

/* CHANGE from amino acid to number*/
int change(char amnio)
{ int back;

  if(amnio=='A') return (0);
  if(amnio=='R') return (1); 
  if(amnio=='N') return (2); 
  if(amnio=='D') return (3); 
  if(amnio=='C') return (4); 
  if(amnio=='Q') return (5); 
  if(amnio=='E') return (6); 
  if(amnio=='G') return (7); 
  if(amnio=='H') return (8);
  if(amnio=='I') return (9); 
  if(amnio=='L') return (10); 
  if(amnio=='K') return (11); 
  if(amnio=='M') return (12); 
  if(amnio=='F') return (13); 
  if(amnio=='P') return (14); 
  if(amnio=='S') return (15);
  if(amnio=='T') return (16); 
  if(amnio=='W') return (17); 
  if(amnio=='Y') return (18); 
  if(amnio=='V') return (19);
}

/* parsimony process*/
int parsimony(int site)
{ int downManipulate(int,int,int);
  void  upManipulate(int,int,int);
  void  finalManipulate(int,int,int,int);
  int i,j,k,step,sister;   
  char aminoAcid[20]={'A','R','N','D','C','Q','E','G','H','I','L','K','M','F','P','S','T','W','Y','V'};

  step=0;
  for(i=0;i<=2*seqNum-2;i++) {
     for(j=0;j<20;j++) {
       downPass[i][j]=-1; upPass[i][j]=-1;
     }
  }
  for(i=1;i<=seqNum;i++) downPass[i][0]=sequenceN[i-1][site];


 out500:;
 for(i=seqNum+1;i<=2*seqNum-2;i++) {
    if((downPass[treeL[i]][0]!=-1)&&(downPass[treeR[i]][0]!=-1)&&(downPass[i][0]==-1)) {
           step=step+downManipulate(i,treeL[i],treeR[i]);
    }
 }

 for(i=seqNum+1;i<=2*seqNum-2;i++) {
    if(downPass[i][0]==-1) goto out500;
 }
 step=step+downManipulate(0,seqNum+1,treeE);

 for(i=0;i<20;i++) upPass[seqNum+1][i]=downPass[treeE][i]; 
 for(i=0;i<20;i++) upPass[treeE][i]=downPass[seqNum+1][i];


 out501:;
 for(i=seqNum+2;i<=2*seqNum-2;i++) {
    if(i!=treeE) {
      if((upPass[parent[i]][0]!=-1)&&(upPass[i][0]==-1)) {
         sister=treeR[parent[i]]; if(sister==i) sister=treeL[parent[i]];
         upManipulate(i,parent[i],sister);
       }
    }
  }

 for(i=seqNum+1;i<=2*seqNum-2;i++) {
   if(upPass[i][0]==-1) goto out501;
 }
 for(i=seqNum+1;i<=seqNum*2-2;i++) {
    finalManipulate(site,i,treeL[i],treeR[i]);
 }
/*
 if(site==1) {
   for(j=seqNum+1;j<=2*seqNum-2;j++) {
      printf("\n");fflush(stdout);
      for (k=0;k<20;k++) {if(upPass[j][k]>=0) printf("%c ",aminoAcid[upPass[j][k]]);fflush(stdout);}
   }
 exit(1);
 }
*/
return(step);
}



int downManipulate(int center, int left, int right)
{ int i,j,k,result;
  k=0;result=0;
  for (i=0;i<20;i++) {
    for (j=0;j<20;j++) {
      if((downPass[left][i]>=0)&&(downPass[right][j]>=0)) {
         if(downPass[left][i]==downPass[right][j]) {downPass[center][k]=downPass[left][i];k=k+1;}
       }
    }
  }
  if(k==0) {
    result=1;
    for(i=0;i<20;i++) {
       if(downPass[left][i]<0) goto out1000;
       downPass[center][k]=downPass[left][i];k=k+1;
    }  
    out1000:;
    for(i=0;i<20;i++) {
       if(downPass[right][i]<0) goto out1001;
       downPass[center][k]=downPass[right][i];k=k+1;
    }
  out1001:;
  }
  return(result);
}



 
void upManipulate(int center, int left, int right)
{ int i,j,k; 
  k=0;
  for (i=0;i<20;i++) {
    for (j=0;j<20;j++) {
      if((upPass[left][i]>=0)&&(downPass[right][j]>=0)) {
         if(upPass[left][i]==downPass[right][j]) {upPass[center][k]=upPass[left][i];k=k+1;}
       }
    }
  }
  if(k==0) {
    
    for(i=0;i<20;i++) {
       if(upPass[left][i]<0) goto out1000;
       upPass[center][k]=upPass[left][i];k=k+1;
    }  
    out1000:;
    for(i=0;i<20;i++) {
       if(downPass[right][i]<0) goto out1001;
       upPass[center][k]=downPass[right][i];k=k+1;
    }
  out1001:;
  }
}


void finalManipulate(int site, int center,int left,int right)
{ int set1[20],set2[20], set3[20];
  int i,j,k,count;
  k=0; 
  for (i=0;i<20;i++) {
   set1[i]=-1; set2[i]=-1; set3[i]=-1, multiState[site][center][i]=-1;
  }

  for (i=0;i<20;i++) {
     for(j=0;j<20;j++) {
        if((upPass[center][i]!=-1) && (downPass[left][j]!=-1)) {
            if(upPass[center][i]==downPass[left][j])  {
                set1[k]=upPass[center][i];k=k+1;
	    }
        }
     }     
  }
 k=0;
 for (i=0;i<20;i++) {
     for(j=0;j<20;j++) {
        if((set1[i]!=-1) && (downPass[right][j]!=-1)) {
            if(set1[i]==downPass[right][j])  {
                multiState[site][center][k]=set1[i];k=k+1;
	    }
        }
     }
  }


 if(multiState[site][center][0]==-1) {
   k=0;
   for (i=0;i<20;i++) {
     for(j=0;j<20;j++) {
        if((upPass[center][i]!=-1) && (downPass[right][j]!=-1)) {
            if(upPass[center][i]==downPass[right][j])  {
                set2[k]=upPass[center][i];k=k+1;
	    }
        }
     }     
  }

 k=0;
 for (i=0;i<20;i++) {
     for(j=0;j<20;j++) {
        if((downPass[right][i]!=-1) && (downPass[left][j]!=-1)) {
            if(downPass[right][i]==downPass[left][j])  {
                set3[k]=downPass[right][i];k=k+1;
	    }
        }
     }     
  }

 count=0;
 for(i=0;i<20;i++) {
       multiState[site][center][i]=set1[i];
       if(set1[i]!=-1) count=count+1;
 }

 for(i=0;i<20;i++) {
     for(j=0;j<20;j++) {
        if((set2[i]==-1)||(set2[i]==multiState[site][center][j])) goto out503;
     }
     multiState[site][center][count]=set2[i];
     count=count+1;
     out503:; 
 }
 for(i=0;i<20;i++) {
     for(j=0;j<20;j++) {
        if((set3[i]==-1)||(set3[i]==multiState[site][center][j])) goto out504;
      }
     multiState[site][center][count]=set3[i];
     count=count+1;
     out504:;
 }

}

  if(multiState[site][center][0]==-1) { 
     k=0;
     for(i=0;i<20;i++) {
       if(upPass[center][i]<0) goto out1100;
           multiState[site][center][k]=upPass[center][i];k=k+1;
    }  
    out1100:;
    for(i=0;i<20;i++) {
       if(downPass[right][i]<0) goto out1101;
         multiState[site][center][k]=downPass[right][i];k=k+1;
    }
    out1101:;
    for(i=0;i<20;i++) {
       if(downPass[left][i]<0) goto out1102;
         multiState[site][center][k]=downPass[left][i];k=k+1;
    }
    out1102:;
 
   }
}





double totalProb(int site)
{
 int i,j,k,k1,k2;
 double **likelihood;
 double sum1,sum2,sum3,sum;

 likelihood=malloc(sizeof(double *)*(seqNum*2-1));
   for(i=0;i<seqNum*2-1;i++)  likelihood[i]=malloc(sizeof(double)*21);
 
 for(i=1;i<seqNum+1;i++) {
   for(j=0;j<20;j++) {
      likelihood[i][j]=0.0;
      if(j==sequenceN[i-1][site]) likelihood[i][j]=1.0;
    }
   likelihood[i][20]=1.0;
 }


 for(i=seqNum+1;i<=2*seqNum-2;i++) {
   likelihood[i][20]=-1.0;
 }

 out600:;
 for(i=seqNum+2;i<seqNum*2-1;i++) {
   if((likelihood[treeL[i]][20]>.0)&&(likelihood[treeR[i]][20]>.0)&&(likelihood[i][20]<.0)) {
     likelihood[i][20]=1.0;
     for(j=0;j<seqNum*2-3;j++) {
       if(branchL[j]==i&&branchR[j]==treeL[i]) k1=j; 
       if(branchL[j]==i&&branchR[j]==treeR[i]) k2=j;
     }
     for(j=0;j<20;j++) {sum1=.0;sum2=.0;
        for(k=0;k<20;k++){
          sum1=sum1+likelihood[treeL[i]][k]*probability[k1][j][k];
        }
        for(k=0;k<20;k++){
          sum2=sum2+likelihood[treeR[i]][k]*probability[k2][j][k];
        }
        likelihood[i][j]=sum1*sum2;
     }
   }
 }
 for(i=seqNum+2;i<seqNum*2-1;i++) {
   if(likelihood[i][20]<.0) goto out600;
 }

 
 for(j=0;j<seqNum*2-3;j++) {
       if(branchL[j]==seqNum+1&&branchR[j]==treeR[seqNum+1]) k1=j; 
 }
 for(j=0;j<20;j++) { 
        sum1=sum2=sum3=.0; 
        for(k=0;k<20;k++){
          sum1=sum1+likelihood[treeL[seqNum+1]][k]*probability[0][j][k];
        } 
        for(k=0;k<20;k++){
          sum2=sum2+likelihood[treeR[seqNum+1]][k]*probability[k1][j][k];
        } 
        for(k=0;k<20;k++){
          sum3=sum3+likelihood[treeE][k]*probability[seqNum*2-4][j][k];
        }
        likelihood[seqNum+1][j]=sum1*sum2*sum3*freq[j];
 }
 sum=.0;
 for(j=0;j<20;j++) {
   sum=sum+likelihood[seqNum+1][j];
 }
 return(sum);

   for(i=0;i<seqNum*2-1;i++)  free(likelihood[i]);
   free(likelihood);

}


void jttf()
{
  int i,j,k;
  double aDouble;

  aDouble=1.0/(seqLength*seqNum+.0);
  for(i=0;i<20;i++)  freqObs[i]=.0;
  for(i=0;i<seqNum;i++) {
     for(j=0;j<seqLength;j++) {
         freqObs[sequenceN[i][j]]=freqObs[sequenceN[i][j]]+aDouble;
       }
   }
  for(i=0;i<20;i++) {
    prob[i][i]=1.0;
    for(j=0;j<20;j++) {
      if(i!=j) {
             prob[i][j]=prob[i][j]/freq[j]*freqObs[j];
             prob[i][i]=prob[i][i]-prob[i][j];
      }
    }
  }
  for(i=0;i<20;i++) {
     freq[i]=freqObs[i];
  }
}


double nodeByNode(int site, int node, int xxx)
{
 int i,j,k,k1,k2;
 double **likelihood;
 double sum1,sum2,sum3,sum;

 likelihood=malloc(sizeof(double *)*(seqNum*2-1));
   for(i=0;i<seqNum*2-1;i++)  likelihood[i]=malloc(sizeof(double)*21);

 for(i=1;i<seqNum+1;i++) {
   for(j=0;j<20;j++) {
      likelihood[i][j]=0.0;
      if(j==sequenceN[i-1][site]) likelihood[i][j]=1.0;
    }
   likelihood[i][20]=1.0;
 }

 for(i=seqNum+1;i<=2*seqNum-2;i++) {
   likelihood[i][20]=-1.0;
 }

 out600:;
 for(i=seqNum+2;i<seqNum*2-1;i++) {
   if((likelihood[treeL[i]][20]>.0)&&(likelihood[treeR[i]][20]>.0)&&(likelihood[i][20]<.0)) {
     likelihood[i][20]=1.0;
     for(j=0;j<seqNum*2-3;j++) {
       if(branchL[j]==i&&branchR[j]==treeL[i]) k1=j;
       if(branchL[j]==i&&branchR[j]==treeR[i]) k2=j;
     }
     for(j=0;j<20;j++) {sum1=.0;sum2=.0;
        for(k=0;k<20;k++){
          sum1=sum1+likelihood[treeL[i]][k]*probability[k1][j][k];
        }
        for(k=0;k<20;k++){
          sum2=sum2+likelihood[treeR[i]][k]*probability[k2][j][k];
        }
        likelihood[i][j]=sum1*sum2;
        
     }
     if(node==i) {
        for(j=0;j<20;j++) {
             if(j!=xxx) likelihood[i][j]=.0;
        }
     }

   }
 }

 for(i=seqNum+2;i<seqNum*2-1;i++) {
   if(likelihood[i][20]<.0) goto out600;
 }

 for(j=0;j<seqNum*2-3;j++) {
       if(branchL[j]==seqNum+1&&branchR[j]==treeR[seqNum+1]) k1=j; 
 } 

 if((seqNum+1)!=node) {
   for(j=0;j<20;j++) {     sum1=sum2=sum3=.0;
    
        for(k=0;k<20;k++){
          sum1=sum1+likelihood[treeL[seqNum+1]][k]*probability[0][j][k];
        } 
        for(k=0;k<20;k++){
          sum2=sum2+likelihood[treeR[seqNum+1]][k]*probability[k1][j][k];
        } 
        for(k=0;k<20;k++){
          sum3=sum3+likelihood[treeE][k]*probability[seqNum*2-4][j][k];
        }
        likelihood[seqNum+1][j]=sum1*sum2*sum3*freqObs[j];
   }
 }

 else { 
        for(j=0;j<20;j++) likelihood[seqNum+1][j]=.0;
        j=xxx;
        sum1=sum2=sum3=.0;

        for(k=0;k<20;k++){
          sum1=sum1+likelihood[treeL[seqNum+1]][k]*probability[0][j][k];
        } 
        for(k=0;k<20;k++){
          sum2=sum2+likelihood[treeR[seqNum+1]][k]*probability[k1][j][k];
        } 
        for(k=0;k<20;k++){
          sum3=sum3+likelihood[treeE][k]*probability[seqNum*2-4][j][k];
        }
        likelihood[seqNum+1][j]=sum1*sum2*sum3*freqObs[j];
 }

 sum=.0;
 for(j=0;j<20;j++) {
   sum=sum+likelihood[seqNum+1][j];
 }
  for(i=0;i<seqNum*2-1;i++)  free(likelihood[i]); 
   free(likelihood);
/* if(sum>.000001) {printf("%e ",sum),fflush(stdout);}*/
 return(sum);
}
